# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from enu/FromFixRequest.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import std_msgs.msg
import sensor_msgs.msg

class FromFixRequest(genpy.Message):
  _md5sum = "592b2fb1c3dae6914312f4d61150e699"
  _type = "enu/FromFixRequest"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """sensor_msgs/NavSatFix llh
sensor_msgs/NavSatFix datum

================================================================================
MSG: sensor_msgs/NavSatFix
# Navigation Satellite fix for any Global Navigation Satellite System
#
# Specified using the WGS 84 reference ellipsoid

# header.stamp specifies the ROS time for this measurement (the
#        corresponding satellite time may be reported using the
#        sensor_msgs/TimeReference message).
#
# header.frame_id is the frame of reference reported by the satellite
#        receiver, usually the location of the antenna.  This is a
#        Euclidean frame relative to the vehicle, not a reference
#        ellipsoid.
Header header

# satellite fix status information
NavSatStatus status

# Latitude [degrees]. Positive is north of equator; negative is south.
float64 latitude

# Longitude [degrees]. Positive is east of prime meridian; negative is west.
float64 longitude

# Altitude [m]. Positive is above the WGS 84 ellipsoid
# (quiet NaN if no altitude is available).
float64 altitude

# Position covariance [m^2] defined relative to a tangential plane
# through the reported position. The components are East, North, and
# Up (ENU), in row-major order.
#
# Beware: this coordinate system exhibits singularities at the poles.

float64[9] position_covariance

# If the covariance of the fix is known, fill it in completely. If the
# GPS receiver provides the variance of each measurement, put them
# along the diagonal. If only Dilution of Precision is available,
# estimate an approximate covariance from that.

uint8 COVARIANCE_TYPE_UNKNOWN = 0
uint8 COVARIANCE_TYPE_APPROXIMATED = 1
uint8 COVARIANCE_TYPE_DIAGONAL_KNOWN = 2
uint8 COVARIANCE_TYPE_KNOWN = 3

uint8 position_covariance_type

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: sensor_msgs/NavSatStatus
# Navigation Satellite fix status for any Global Navigation Satellite System

# Whether to output an augmented fix is determined by both the fix
# type and the last time differential corrections were received.  A
# fix is valid when status >= STATUS_FIX.

int8 STATUS_NO_FIX =  -1        # unable to fix position
int8 STATUS_FIX =      0        # unaugmented fix
int8 STATUS_SBAS_FIX = 1        # with satellite-based augmentation
int8 STATUS_GBAS_FIX = 2        # with ground-based augmentation

int8 status

# Bits defining which Global Navigation Satellite System signals were
# used by the receiver.

uint16 SERVICE_GPS =     1
uint16 SERVICE_GLONASS = 2
uint16 SERVICE_COMPASS = 4      # includes BeiDou.
uint16 SERVICE_GALILEO = 8

uint16 service
"""
  __slots__ = ['llh','datum']
  _slot_types = ['sensor_msgs/NavSatFix','sensor_msgs/NavSatFix']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       llh,datum

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(FromFixRequest, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.llh is None:
        self.llh = sensor_msgs.msg.NavSatFix()
      if self.datum is None:
        self.datum = sensor_msgs.msg.NavSatFix()
    else:
      self.llh = sensor_msgs.msg.NavSatFix()
      self.datum = sensor_msgs.msg.NavSatFix()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.llh.header.seq, _x.llh.header.stamp.secs, _x.llh.header.stamp.nsecs))
      _x = self.llh.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_bH3d.pack(_x.llh.status.status, _x.llh.status.service, _x.llh.latitude, _x.llh.longitude, _x.llh.altitude))
      buff.write(_struct_9d.pack(*self.llh.position_covariance))
      _x = self
      buff.write(_struct_B3I.pack(_x.llh.position_covariance_type, _x.datum.header.seq, _x.datum.header.stamp.secs, _x.datum.header.stamp.nsecs))
      _x = self.datum.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_bH3d.pack(_x.datum.status.status, _x.datum.status.service, _x.datum.latitude, _x.datum.longitude, _x.datum.altitude))
      buff.write(_struct_9d.pack(*self.datum.position_covariance))
      buff.write(_struct_B.pack(self.datum.position_covariance_type))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.llh is None:
        self.llh = sensor_msgs.msg.NavSatFix()
      if self.datum is None:
        self.datum = sensor_msgs.msg.NavSatFix()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.llh.header.seq, _x.llh.header.stamp.secs, _x.llh.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.llh.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.llh.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 27
      (_x.llh.status.status, _x.llh.status.service, _x.llh.latitude, _x.llh.longitude, _x.llh.altitude,) = _struct_bH3d.unpack(str[start:end])
      start = end
      end += 72
      self.llh.position_covariance = _struct_9d.unpack(str[start:end])
      _x = self
      start = end
      end += 13
      (_x.llh.position_covariance_type, _x.datum.header.seq, _x.datum.header.stamp.secs, _x.datum.header.stamp.nsecs,) = _struct_B3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.datum.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.datum.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 27
      (_x.datum.status.status, _x.datum.status.service, _x.datum.latitude, _x.datum.longitude, _x.datum.altitude,) = _struct_bH3d.unpack(str[start:end])
      start = end
      end += 72
      self.datum.position_covariance = _struct_9d.unpack(str[start:end])
      start = end
      end += 1
      (self.datum.position_covariance_type,) = _struct_B.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.llh.header.seq, _x.llh.header.stamp.secs, _x.llh.header.stamp.nsecs))
      _x = self.llh.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_bH3d.pack(_x.llh.status.status, _x.llh.status.service, _x.llh.latitude, _x.llh.longitude, _x.llh.altitude))
      buff.write(self.llh.position_covariance.tostring())
      _x = self
      buff.write(_struct_B3I.pack(_x.llh.position_covariance_type, _x.datum.header.seq, _x.datum.header.stamp.secs, _x.datum.header.stamp.nsecs))
      _x = self.datum.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_bH3d.pack(_x.datum.status.status, _x.datum.status.service, _x.datum.latitude, _x.datum.longitude, _x.datum.altitude))
      buff.write(self.datum.position_covariance.tostring())
      buff.write(_struct_B.pack(self.datum.position_covariance_type))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.llh is None:
        self.llh = sensor_msgs.msg.NavSatFix()
      if self.datum is None:
        self.datum = sensor_msgs.msg.NavSatFix()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.llh.header.seq, _x.llh.header.stamp.secs, _x.llh.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.llh.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.llh.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 27
      (_x.llh.status.status, _x.llh.status.service, _x.llh.latitude, _x.llh.longitude, _x.llh.altitude,) = _struct_bH3d.unpack(str[start:end])
      start = end
      end += 72
      self.llh.position_covariance = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=9)
      _x = self
      start = end
      end += 13
      (_x.llh.position_covariance_type, _x.datum.header.seq, _x.datum.header.stamp.secs, _x.datum.header.stamp.nsecs,) = _struct_B3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.datum.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.datum.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 27
      (_x.datum.status.status, _x.datum.status.service, _x.datum.latitude, _x.datum.longitude, _x.datum.altitude,) = _struct_bH3d.unpack(str[start:end])
      start = end
      end += 72
      self.datum.position_covariance = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=9)
      start = end
      end += 1
      (self.datum.position_covariance_type,) = _struct_B.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_3I = struct.Struct("<3I")
_struct_bH3d = struct.Struct("<bH3d")
_struct_9d = struct.Struct("<9d")
_struct_B = struct.Struct("<B")
_struct_B3I = struct.Struct("<B3I")
# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from enu/FromFixResponse.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg

class FromFixResponse(genpy.Message):
  _md5sum = "a7c84ff13976aa04656e56e300124444"
  _type = "enu/FromFixResponse"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """geometry_msgs/Point point


================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z
"""
  __slots__ = ['point']
  _slot_types = ['geometry_msgs/Point']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       point

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(FromFixResponse, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.point is None:
        self.point = geometry_msgs.msg.Point()
    else:
      self.point = geometry_msgs.msg.Point()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_struct_3d.pack(_x.point.x, _x.point.y, _x.point.z))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.point is None:
        self.point = geometry_msgs.msg.Point()
      end = 0
      _x = self
      start = end
      end += 24
      (_x.point.x, _x.point.y, _x.point.z,) = _struct_3d.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_struct_3d.pack(_x.point.x, _x.point.y, _x.point.z))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.point is None:
        self.point = geometry_msgs.msg.Point()
      end = 0
      _x = self
      start = end
      end += 24
      (_x.point.x, _x.point.y, _x.point.z,) = _struct_3d.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_3d = struct.Struct("<3d")
class FromFix(object):
  _type          = 'enu/FromFix'
  _md5sum = '0b648a6d138b4916e4013d4655e31948'
  _request_class  = FromFixRequest
  _response_class = FromFixResponse
